diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/type-id.h ns-3.39/src/core/model/type-id.h
--- ns-3.38/src/core/model/type-id.h	2023-03-16 20:54:51.628957000 -0700
+++ ns-3.39/src/core/model/type-id.h	2023-07-05 14:23:47.765427000 -0700
@@ -23,7 +23,6 @@
 #include "attribute-helper.h"
 #include "attribute.h"
 #include "callback.h"
-#include "deprecated.h"
 #include "hash.h"
 #include "trace-source-accessor.h"
 
@@ -262,7 +261,7 @@
      * \param [in] i Index into attribute array
      * \returns The information associated to attribute whose index is \pname{i}.
      */
-    struct TypeId::AttributeInformation GetAttribute(std::size_t i) const;
+    TypeId::AttributeInformation GetAttribute(std::size_t i) const;
     /**
      * Get the Attribute name by index.
      *
@@ -298,7 +297,7 @@
      * \param [in] i Index into trace source array.
      * \returns Detailed information about the requested trace source.
      */
-    struct TypeId::TraceSourceInformation GetTraceSource(std::size_t i) const;
+    TypeId::TraceSourceInformation GetTraceSource(std::size_t i) const;
 
     /**
      * Set the parent TypeId.
@@ -474,7 +473,7 @@
      *              will be stored.
      * \returns \c true if the requested attribute could be found.
      */
-    bool LookupAttributeByName(std::string name, struct AttributeInformation* info) const;
+    bool LookupAttributeByName(std::string name, AttributeInformation* info) const;
     /**
      * Find a TraceSource by name.
      *
@@ -497,9 +496,8 @@
      *  and disconnect trace sinks with the requested trace source on
      *  an object instance.
      */
-    Ptr<const TraceSourceAccessor> LookupTraceSourceByName(
-        std::string name,
-        struct TraceSourceInformation* info) const;
+    Ptr<const TraceSourceAccessor> LookupTraceSourceByName(std::string name,
+                                                           TraceSourceInformation* info) const;
 
     /**
      * Get the internal id of this TypeId.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/unix-fd-reader.cc ns-3.39/src/core/model/unix-fd-reader.cc
--- ns-3.38/src/core/model/unix-fd-reader.cc	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/unix-fd-reader.cc	2023-07-05 14:23:47.765427000 -0700
@@ -218,7 +218,7 @@
 
         if (FD_ISSET(m_fd, &readfds))
         {
-            struct FdReader::Data data = DoRead();
+            FdReader::Data data = DoRead();
             // reading stops when m_len is zero
             if (data.m_len == 0)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/val-array.h ns-3.39/src/core/model/val-array.h
--- ns-3.38/src/core/model/val-array.h	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/val-array.h	2023-07-05 14:23:47.765427000 -0700
@@ -89,7 +89,7 @@
      * \param numCols the number of columns
      * \param numPages the number of pages
      */
-    ValArray<T>(uint16_t numRows, uint16_t numCols = 1, uint16_t numPages = 1);
+    ValArray<T>(size_t numRows, size_t numCols = 1, size_t numPages = 1);
     /**
      * \brief Constructor creates a single 1D array of values.size () elements and 1 column,
      * and uses std::valarray<T> values to initialize the elements.
@@ -115,7 +115,7 @@
      * \param numCols the number of columns
      * \param values valarray<T> that will be used to initialize elements of 3D array
      */
-    ValArray<T>(uint16_t numRows, uint16_t numCols, const std::valarray<T>& values);
+    ValArray<T>(size_t numRows, size_t numCols, const std::valarray<T>& values);
     /**
      * \brief Constructor creates a single 2D array of numRows and numCols, and moves
      * std::valarray<T> values to initialize the elements.
@@ -123,7 +123,7 @@
      * \param numCols the number of columns
      * \param values valarray<T> that will be used to initialize elements of 3D array
      */
-    ValArray<T>(uint16_t numRows, uint16_t numCols, std::valarray<T>&& values);
+    ValArray<T>(size_t numRows, size_t numCols, std::valarray<T>&& values);
     /**
      * \brief Constructor creates the 3D array of numRows x numCols x numPages dimensions,
      * and uses std::valarray<T> values to initialize all the 2D arrays, where first
@@ -133,10 +133,7 @@
      * \param numPages the number of pages
      * \param values valarray<T> that will be used to initialize elements of 3D array
      */
-    ValArray<T>(uint16_t numRows,
-                uint16_t numCols,
-                uint16_t numPages,
-                const std::valarray<T>& values);
+    ValArray<T>(size_t numRows, size_t numCols, size_t numPages, const std::valarray<T>& values);
     /**
      * \brief Constructor creates the 3D array of numRows x numCols x numPages dimensions,
      * and moves std::valarray<T> values to initialize all the 2D arrays, where first
@@ -146,7 +143,7 @@
      * \param numPages the number of pages
      * \param values valarray<T> that will be used to initialize elements of 3D array
      */
-    ValArray<T>(uint16_t numRows, uint16_t numCols, uint16_t numPages, std::valarray<T>&& values);
+    ValArray<T>(size_t numRows, size_t numCols, size_t numPages, std::valarray<T>&& values);
     /** instruct the compiler to generate the implicitly declared destructor*/
     virtual ~ValArray<T>() = default;
     /** instruct the compiler to generate the implicitly declared copy constructor*/
@@ -168,15 +165,15 @@
     /**
      * \returns Number of rows
      */
-    uint16_t GetNumRows() const;
+    size_t GetNumRows() const;
     /**
      * \returns Number of columns
      */
-    uint16_t GetNumCols() const;
+    size_t GetNumCols() const;
     /**
      * \returns Number of pages, i.e., the number of 2D arrays
      */
-    uint16_t GetNumPages() const;
+    size_t GetNumPages() const;
     /**
      * \returns Total number of elements
      */
@@ -188,7 +185,7 @@
      * \param pageIndex The index of the page
      * \returns A const reference to the element with with rowIndex, colIndex and pageIndex indices.
      */
-    T& operator()(uint16_t rowIndex, uint16_t colIndex, uint16_t pageIndex);
+    T& operator()(size_t rowIndex, size_t colIndex, size_t pageIndex);
     /**
      * \brief Const access operator, with bound-checking in debug profile
      * \param rowIndex The index of the row
@@ -196,7 +193,7 @@
      * \param pageIndex The index of the page
      * \returns A const reference to the element with with rowIndex, colIndex and pageIndex indices.
      */
-    const T& operator()(uint16_t rowIndex, uint16_t colIndex, uint16_t pageIndex) const;
+    const T& operator()(size_t rowIndex, size_t colIndex, size_t pageIndex) const;
     /**
      * \brief Access operator for 2D ValArrays.
      * Assuming that the third dimension is equal to 1, e.g. ValArray contains
@@ -209,7 +206,7 @@
      * \param colIndex The index of the column
      * \returns A reference to the element with the specified indices
      */
-    T& operator()(uint16_t rowIndex, uint16_t colIndex);
+    T& operator()(size_t rowIndex, size_t colIndex);
     /**
      * \brief Const access operator for 2D ValArrays.
      * Assuming that the third dimension is equal to 1, e.g. ValArray contains
@@ -218,7 +215,7 @@
      * \param colIndex column index
      * \returns a Const reference to the value with the specified row and column index.
      */
-    const T& operator()(uint16_t rowIndex, uint16_t colIndex) const;
+    const T& operator()(size_t rowIndex, size_t colIndex) const;
     /**
      * \brief Single-element access operator() for 1D ValArrays.
      * Assuming that the number of columns and pages is equal to 1, e.g. ValArray
@@ -230,13 +227,13 @@
      * \param index The index of the 1D ValArray.
      * \returns A reference to the value with the specified index.
      */
-    T& operator()(uint16_t index);
+    T& operator()(size_t index);
     /**
      * \brief Single-element access operator() for 1D ValArrays.
      * \param index The index of the 1D ValArray.
      * \returns The const reference to the values with the specified index.
      */
-    const T& operator()(uint16_t index) const;
+    const T& operator()(size_t index) const;
     /**
      * \brief Element-wise multiplication with a scalar value.
      * \param rhs A scalar value of type T
@@ -302,14 +299,14 @@
      * \param pageIndex The index of the desired 2D array
      * \returns a pointer to the data elements of the 2D array
      */
-    T* GetPagePtr(uint16_t pageIndex);
+    T* GetPagePtr(size_t pageIndex);
     /**
      * \brief Get a data pointer to a specific 2D array for use in linear
      * algebra libraries
      * \param pageIndex An index of the desired 2D array
      * \returns a pointer to the data elements of the 2D array
      */
-    const T* GetPagePtr(uint16_t pageIndex) const;
+    const T* GetPagePtr(size_t pageIndex) const;
     /**
      * \brief Checks whether rhs and lhs ValArray objects have the same dimensions.
      * \param rhs The rhs ValArray
@@ -365,11 +362,11 @@
     const T& Elem(size_t row, size_t col, size_t page) const;
 
   protected:
-    uint16_t m_numRows =
+    size_t m_numRows =
         0; //!< The size of the first dimension, i.e., the number of rows of each 2D array
-    uint16_t m_numCols =
+    size_t m_numCols =
         0; //!< The size of the second dimension, i.e., the number of columns of each 2D array
-    uint16_t m_numPages = 0;   //!< The size of the third dimension, i.e., the number of 2D arrays
+    size_t m_numPages = 0;     //!< The size of the third dimension, i.e., the number of 2D arrays
     std::valarray<T> m_values; //!< The data values
 };
 
@@ -378,21 +375,21 @@
  ************************************************/
 
 template <class T>
-inline uint16_t
+inline size_t
 ValArray<T>::GetNumRows() const
 {
     return m_numRows;
 };
 
 template <class T>
-inline uint16_t
+inline size_t
 ValArray<T>::GetNumCols() const
 {
     return m_numCols;
 };
 
 template <class T>
-inline uint16_t
+inline size_t
 ValArray<T>::GetNumPages() const
 {
     return m_numPages;
@@ -407,7 +404,7 @@
 
 template <class T>
 inline T&
-ValArray<T>::operator()(uint16_t rowIndex, uint16_t colIndex, uint16_t pageIndex)
+ValArray<T>::operator()(size_t rowIndex, size_t colIndex, size_t pageIndex)
 {
     NS_ASSERT_MSG(rowIndex < m_numRows, "Row index out of bounds");
     NS_ASSERT_MSG(colIndex < m_numCols, "Column index out of bounds");
@@ -418,7 +415,7 @@
 
 template <class T>
 inline const T&
-ValArray<T>::operator()(uint16_t rowIndex, uint16_t colIndex, uint16_t pageIndex) const
+ValArray<T>::operator()(size_t rowIndex, size_t colIndex, size_t pageIndex) const
 {
     NS_ASSERT_MSG(rowIndex < m_numRows, "Row index out of bounds");
     NS_ASSERT_MSG(colIndex < m_numCols, "Column index out of bounds");
@@ -429,7 +426,7 @@
 
 template <class T>
 inline T&
-ValArray<T>::operator()(uint16_t rowIndex, uint16_t colIndex)
+ValArray<T>::operator()(size_t rowIndex, size_t colIndex)
 {
     NS_ASSERT_MSG(m_numPages == 1, "Cannot use 2D access operator for 3D ValArray.");
     return (*this)(rowIndex, colIndex, 0);
@@ -437,7 +434,7 @@
 
 template <class T>
 inline const T&
-ValArray<T>::operator()(uint16_t rowIndex, uint16_t colIndex) const
+ValArray<T>::operator()(size_t rowIndex, size_t colIndex) const
 {
     NS_ASSERT_MSG(m_numPages == 1, "Cannot use 2D access operator for 3D ValArray.");
     return (*this)(rowIndex, colIndex, 0);
@@ -445,7 +442,7 @@
 
 template <class T>
 inline T&
-ValArray<T>::operator()(uint16_t index)
+ValArray<T>::operator()(size_t index)
 {
     NS_ASSERT_MSG(index < m_values.size(),
                   "Invalid index to 1D ValArray. The size of the array should be set through "
@@ -458,7 +455,7 @@
 
 template <class T>
 inline const T&
-ValArray<T>::operator()(uint16_t index) const
+ValArray<T>::operator()(size_t index) const
 {
     NS_ASSERT_MSG(index < m_values.size(),
                   "Invalid index to 1D ValArray.The size of the array should be set through "
@@ -522,7 +519,7 @@
 
 template <class T>
 inline T*
-ValArray<T>::GetPagePtr(uint16_t pageIndex)
+ValArray<T>::GetPagePtr(size_t pageIndex)
 {
     NS_ASSERT_MSG(pageIndex < m_numPages, "Invalid page index.");
     return &(m_values[m_numRows * m_numCols * pageIndex]);
@@ -530,7 +527,7 @@
 
 template <class T>
 inline const T*
-ValArray<T>::GetPagePtr(uint16_t pageIndex) const
+ValArray<T>::GetPagePtr(size_t pageIndex) const
 {
     NS_ASSERT_MSG(pageIndex < m_numPages, "Invalid page index.");
     return &(m_values[m_numRows * m_numCols * pageIndex]);
@@ -584,7 +581,7 @@
  ************************************************/
 
 template <class T>
-ValArray<T>::ValArray(uint16_t numRows, uint16_t numCols, uint16_t numPages)
+ValArray<T>::ValArray(size_t numRows, size_t numCols, size_t numPages)
     : m_numRows{numRows},
       m_numCols{numCols},
       m_numPages{numPages}
@@ -594,7 +591,7 @@
 
 template <class T>
 ValArray<T>::ValArray(const std::valarray<T>& values)
-    : m_numRows{(uint16_t)values.size()},
+    : m_numRows{values.size()},
       m_numCols{1},
       m_numPages{1},
       m_values{values}
@@ -603,7 +600,7 @@
 
 template <class T>
 ValArray<T>::ValArray(std::valarray<T>&& values)
-    : m_numRows{(uint16_t)values.size()},
+    : m_numRows{values.size()},
       m_numCols{1},
       m_numPages{1},
       m_values{std::move(values)}
@@ -612,7 +609,7 @@
 
 template <class T>
 ValArray<T>::ValArray(const std::vector<T>& values)
-    : m_numRows{(uint16_t)values.size()},
+    : m_numRows{values.size()},
       m_numCols{1},
       m_numPages{1}
 {
@@ -621,7 +618,7 @@
 }
 
 template <class T>
-ValArray<T>::ValArray(uint16_t numRows, uint16_t numCols, const std::valarray<T>& values)
+ValArray<T>::ValArray(size_t numRows, size_t numCols, const std::valarray<T>& values)
     : m_numRows{numRows},
       m_numCols{numCols},
       m_numPages{1},
@@ -632,7 +629,7 @@
 };
 
 template <class T>
-ValArray<T>::ValArray(uint16_t numRows, uint16_t numCols, std::valarray<T>&& values)
+ValArray<T>::ValArray(size_t numRows, size_t numCols, std::valarray<T>&& values)
     : m_numRows{numRows},
       m_numCols{numCols},
       m_numPages{1}
@@ -643,9 +640,9 @@
 };
 
 template <class T>
-ValArray<T>::ValArray(uint16_t numRows,
-                      uint16_t numCols,
-                      uint16_t numPages,
+ValArray<T>::ValArray(size_t numRows,
+                      size_t numCols,
+                      size_t numPages,
                       const std::valarray<T>& values)
     : m_numRows{numRows},
       m_numCols{numCols},
@@ -657,10 +654,7 @@
 };
 
 template <class T>
-ValArray<T>::ValArray(uint16_t numRows,
-                      uint16_t numCols,
-                      uint16_t numPages,
-                      std::valarray<T>&& values)
+ValArray<T>::ValArray(size_t numRows, size_t numCols, size_t numPages, std::valarray<T>&& values)
     : m_numRows{numRows},
       m_numCols{numCols},
       m_numPages{numPages}
@@ -723,12 +717,12 @@
 operator<<(std::ostream& os, const ValArray<T>& a)
 {
     os << "\n";
-    for (auto p = 0; p != a.GetNumPages(); ++p)
+    for (size_t p = 0; p != a.GetNumPages(); ++p)
     {
         os << "Page " << p << ":\n";
-        for (auto i = 0; i != a.GetNumRows(); ++i)
+        for (size_t i = 0; i != a.GetNumRows(); ++i)
         {
-            for (auto j = 0; j != a.GetNumCols(); ++j)
+            for (size_t j = 0; j != a.GetNumCols(); ++j)
             {
                 os << "\t" << a(i, j, p);
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/version.cache ns-3.39/src/core/model/version.cache
--- ns-3.38/src/core/model/version.cache	2023-03-16 20:55:00.740985900 -0700
+++ ns-3.39/src/core/model/version.cache	2023-07-05 14:24:26.185557800 -0700
@@ -1,10 +1,10 @@
-CLOSEST_TAG = '"ns-3.38"'
-VERSION_COMMIT_HASH = '"g392e36833"'
+CLOSEST_TAG = '"ns-3.39"'
+VERSION_COMMIT_HASH = '"g10b9bc1af"'
 VERSION_DIRTY_FLAG = '0'
 VERSION_MAJOR = '3'
-VERSION_MINOR = '38'
+VERSION_MINOR = '39'
 VERSION_PATCH = '0'
 VERSION_RELEASE_CANDIDATE = '""'
-VERSION_TAG = '"ns-3.38"'
+VERSION_TAG = '"ns-3.39"'
 VERSION_TAG_DISTANCE = '0'
 VERSION_BUILD_PROFILE = 'default'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/wall-clock-synchronizer.cc ns-3.39/src/core/model/wall-clock-synchronizer.cc
--- ns-3.38/src/core/model/wall-clock-synchronizer.cc	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/wall-clock-synchronizer.cc	2023-07-05 14:23:47.769427300 -0700
@@ -227,7 +227,7 @@
         // interrupted by a Signal.  In this case, we need to return and let the
         // simulator re-evaluate what to do.
         //
-        if (SleepWait((numberJiffies - 3) * m_jiffy) == false)
+        if (!SleepWait((numberJiffies - 3) * m_jiffy))
         {
             NS_LOG_INFO("SleepWait interrupted");
             return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/win32-fd-reader.cc ns-3.39/src/core/model/win32-fd-reader.cc
--- ns-3.38/src/core/model/win32-fd-reader.cc	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/win32-fd-reader.cc	2023-07-05 14:23:47.769427300 -0700
@@ -225,7 +225,7 @@
 
         if (FD_ISSET(m_fd, &readfds))
         {
-            struct FdReader::Data data = DoRead();
+            FdReader::Data data = DoRead();
             // reading stops when m_len is zero
             if (data.m_len == 0)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/attribute-container-test-suite.cc ns-3.39/src/core/test/attribute-container-test-suite.cc
--- ns-3.38/src/core/test/attribute-container-test-suite.cc	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/test/attribute-container-test-suite.cc	2023-07-05 14:23:47.769427300 -0700
@@ -32,7 +32,6 @@
 #include <iterator>
 #include <list>
 #include <map>
-#include <sstream>
 #include <utility>
 #include <vector>
 
@@ -59,7 +58,7 @@
     /**
      * Reverses the list of doubles.
      */
-    void ReverseList();
+    void ReverseDoubleList();
 
     /**
      * \brief Get the type ID.
@@ -68,6 +67,19 @@
     static TypeId GetTypeId();
 
     /**
+     * Set the list of doubles to the given list
+     *
+     * \param doubleList the given list
+     */
+    void SetDoubleList(const std::list<double>& doubleList);
+    /**
+     * Get the list of doubles
+     *
+     * \return the list of doubles
+     */
+    std::list<double> GetDoubleList() const;
+
+    /**
      * Set the vector of ints to the given vector
      *
      * \param vec the given vector
@@ -80,20 +92,12 @@
      */
     std::vector<int> GetIntVec() const;
 
-    /**
-     * \brief Stream insertion operator.
-     *
-     * \param [in] os The reference to the output stream.
-     * \param [in] obj The AttributeContainer object.
-     * \returns The reference to the output stream.
-     */
-    friend std::ostream& operator<<(std::ostream& os, const AttributeContainerObject& obj);
-
   private:
     std::list<double> m_doublelist; //!< List of doubles.
     std::vector<int> m_intvec;      //!< Vector of ints.
     // TODO(jared): need PairValue attributevalue to handle std::pair elements
-    std::map<std::string, int> m_map; //!< Map of <std::string, int>.
+    std::map<std::string, int> m_map;                         //!< Map of <std::string, int>.
+    std::map<int64_t, std::list<int64_t>> m_intVecIntMapping; //!< Mapping integers to vectors
 };
 
 AttributeContainerObject::AttributeContainerObject()
@@ -107,6 +111,8 @@
 TypeId
 AttributeContainerObject::GetTypeId()
 {
+    using IntVecMapValue = PairValue<IntegerValue, AttributeContainerValue<IntegerValue>>;
+
     static TypeId tid =
         TypeId("ns3::AttributeContainerObject")
             .SetParent<Object>()
@@ -118,15 +124,16 @@
                           MakeAttributeContainerAccessor<DoubleValue>(
                               &AttributeContainerObject::m_doublelist),
                           MakeAttributeContainerChecker<DoubleValue>(MakeDoubleChecker<double>()))
-            .AddAttribute("IntegerVector",
-                          "Vector of integers",
-                          // the container value container differs from the underlying object
-                          AttributeContainerValue<IntegerValue>(),
-                          // the type of the underlying container cannot be deduced
-                          MakeAttributeContainerAccessor<IntegerValue, std::list>(
-                              &AttributeContainerObject::SetIntVec,
-                              &AttributeContainerObject::GetIntVec),
-                          MakeAttributeContainerChecker<IntegerValue>(MakeIntegerChecker<int>()))
+            .AddAttribute(
+                "IntegerVector",
+                "Vector of integers",
+                // the container value container differs from the underlying object
+                AttributeContainerValue<IntegerValue>(),
+                // the type of the underlying container cannot be deduced
+                MakeAttributeContainerAccessor<IntegerValue, ';', std::list>(
+                    &AttributeContainerObject::SetIntVec,
+                    &AttributeContainerObject::GetIntVec),
+                MakeAttributeContainerChecker<IntegerValue, ';'>(MakeIntegerChecker<int>()))
             .AddAttribute(
                 "MapStringInt",
                 "Map of strings to ints",
@@ -136,17 +143,42 @@
                     &AttributeContainerObject::m_map),
                 MakeAttributeContainerChecker<PairValue<StringValue, IntegerValue>>(
                     MakePairChecker<StringValue, IntegerValue>(MakeStringChecker(),
-                                                               MakeIntegerChecker<int>())));
+                                                               MakeIntegerChecker<int>())))
+            .AddAttribute(
+                "IntVecPairVec",
+                "An example of complex attribute that is defined by a vector of pairs consisting "
+                "of an integer value and a vector of integers. In case a string is used to set "
+                "this attribute, the string shall contain the pairs separated by a semicolon (;); "
+                "in every pair, the integer value and the vector of integers are separated by a "
+                "blank space, and the elements of the vectors are separated by a comma (,) "
+                "without spaces. E.g. \"0 1,2,3; 1 0; 2 0,1\" consists of three pairs containing "
+                "vectors of 3, 1 and 2 elements, respectively.",
+                StringValue(""),
+                MakeAttributeContainerAccessor<IntVecMapValue, ';'>(
+                    &AttributeContainerObject::m_intVecIntMapping),
+                MakeAttributeContainerChecker<IntVecMapValue, ';'>(
+                    MakePairChecker<IntegerValue, AttributeContainerValue<IntegerValue>>(
+                        MakeIntegerChecker<int>(),
+                        MakeAttributeContainerChecker<IntegerValue>(MakeIntegerChecker<int>()))));
     return tid;
 }
 
 void
-AttributeContainerObject::ReverseList()
+AttributeContainerObject::ReverseDoubleList()
 {
     m_doublelist.reverse();
-    std::vector<int> tmp;
-    std::copy_backward(m_intvec.begin(), m_intvec.end(), tmp.begin());
-    m_intvec = tmp;
+}
+
+void
+AttributeContainerObject::SetDoubleList(const std::list<double>& doubleList)
+{
+    m_doublelist = doubleList;
+}
+
+std::list<double>
+AttributeContainerObject::GetDoubleList() const
+{
+    return m_doublelist;
 }
 
 void
@@ -161,23 +193,6 @@
     return m_intvec;
 }
 
-std::ostream&
-operator<<(std::ostream& os, const AttributeContainerObject& obj)
-{
-    os << "AttributeContainerObject: ";
-    bool first = true;
-    for (auto d : obj.m_doublelist)
-    {
-        if (!first)
-        {
-            os << ", ";
-        }
-        os << d;
-        first = false;
-    }
-    return os;
-}
-
 /**
  * \ingroup attribute-tests
  *
@@ -256,7 +271,7 @@
         auto ref = {"one", "two", "three"};
         AttributeContainerValue<StringValue> ac(ref.begin(), ref.end());
 
-        NS_TEST_ASSERT_MSG_EQ(3, ac.GetN(), "Container size mismatch");
+        NS_TEST_ASSERT_MSG_EQ(ref.size(), ac.GetN(), "Container size mismatch");
         auto aciter = ac.Begin();
         for (auto v : ref)
         {
@@ -269,9 +284,9 @@
 
     {
         auto ref = {"one", "two", "three"};
-        AttributeContainerValue<StringValue, std::vector> ac(ref);
+        AttributeContainerValue<StringValue, ',', std::vector> ac(ref);
 
-        NS_TEST_ASSERT_MSG_EQ(3, ac.GetN(), "Container size mismatch");
+        NS_TEST_ASSERT_MSG_EQ(ref.size(), ac.GetN(), "Container size mismatch");
         auto aciter = ac.Begin();
         for (auto v : ref)
         {
@@ -287,7 +302,7 @@
         std::map<std::string, int64_t> ref = {{"one", 1}, {"two", 2}, {"three", 3}};
         AttributeContainerValue<PairValue<StringValue, IntegerValue>> ac(ref);
 
-        NS_TEST_ASSERT_MSG_EQ(3, ac.GetN(), "Container size mismatch");
+        NS_TEST_ASSERT_MSG_EQ(ref.size(), ac.GetN(), "Container size mismatch");
         auto aciter = ac.Begin();
         for (const auto& v : ref)
         {
@@ -366,7 +381,7 @@
     {
         std::string strings = "this is a sentence with words";
 
-        AttributeContainerValue<StringValue> attr(' ');
+        AttributeContainerValue<StringValue, ' '> attr;
         auto checker = MakeAttributeContainerChecker(attr);
         auto acchecker = DynamicCast<AttributeContainerChecker>(checker);
         acchecker->SetItemChecker(MakeStringChecker());
@@ -376,8 +391,7 @@
         NS_TEST_ASSERT_MSG_EQ(attr.GetN(), 6, "Incorrect container size");
 
         std::string reserialized = attr.SerializeToString(checker);
-        std::string canonical = strings;
-        NS_TEST_ASSERT_MSG_EQ(reserialized, canonical, "Reserialization failed");
+        NS_TEST_ASSERT_MSG_EQ(reserialized, strings, "Reserialization failed");
     }
 
     {
@@ -394,8 +408,7 @@
         NS_TEST_ASSERT_MSG_EQ(attr.GetN(), 3, "Incorrect container size");
 
         std::string reserialized = attr.SerializeToString(checker);
-        std::string canonical = pairs;
-        NS_TEST_ASSERT_MSG_EQ(reserialized, canonical, "Reserealization failed");
+        NS_TEST_ASSERT_MSG_EQ(reserialized, pairs, "Reserealization failed");
     }
 }
 
@@ -427,29 +440,24 @@
 {
     Ptr<AttributeContainerObject> obj = CreateObject<AttributeContainerObject>();
     {
-        std::ostringstream oss;
-        oss << *obj;
-        NS_TEST_ASSERT_MSG_EQ(oss.str(),
-                              "AttributeContainerObject: ",
-                              "DoubleList initialized incorrectly");
+        auto doubleList = obj->GetDoubleList();
+        NS_TEST_ASSERT_MSG_EQ(doubleList.empty(), true, "DoubleList initialized incorrectly");
     }
 
-    std::list<double> doubles = {1.1, 2.22, 3.333};
+    const std::list<double> doubles = {1.1, 2.22, 3.333};
     obj->SetAttribute("DoubleList", AttributeContainerValue<DoubleValue>(doubles));
     {
-        std::ostringstream oss;
-        oss << *obj;
-        NS_TEST_ASSERT_MSG_EQ(oss.str(),
-                              "AttributeContainerObject: 1.1, 2.22, 3.333",
+        auto doubleList = obj->GetDoubleList();
+        NS_TEST_ASSERT_MSG_EQ(std::equal(doubles.begin(), doubles.end(), doubleList.begin()),
+                              true,
                               "DoubleList incorrectly set");
     }
 
-    obj->ReverseList();
+    obj->ReverseDoubleList();
     {
-        std::ostringstream oss;
-        oss << *obj;
-        NS_TEST_ASSERT_MSG_EQ(oss.str(),
-                              "AttributeContainerObject: 3.333, 2.22, 1.1",
+        auto doubleList = obj->GetDoubleList();
+        NS_TEST_ASSERT_MSG_EQ(std::equal(doubles.rbegin(), doubles.rend(), doubleList.begin()),
+                              true,
                               "DoubleList incorrectly reversed");
 
         // NOTE: changing the return container here too!
@@ -459,32 +467,58 @@
 
         AttributeContainerValue<DoubleValue>::result_type doublevec = value.Get();
         NS_TEST_ASSERT_MSG_EQ(doubles.size(), doublevec.size(), "DoublesVec wrong size");
-        auto iter = doubles.rbegin();
-        for (auto d : doublevec)
-        {
-            NS_TEST_ASSERT_MSG_EQ(d, *iter, "Incorrect value in doublesvec");
-            ++iter;
-        }
+        NS_TEST_ASSERT_MSG_EQ(std::equal(doubles.rbegin(), doubles.rend(), doublevec.begin()),
+                              true,
+                              "Incorrect value in doublesvec");
     }
 
-    std::vector<int> ints = {-1, 0, 1, 2, 3};
+    const std::vector<int> ints = {-1, 0, 1, 2, 3};
     // NOTE: here the underlying attribute container type differs from the actual container
-    obj->SetAttribute("IntegerVector", AttributeContainerValue<IntegerValue>(ints));
+    obj->SetAttribute("IntegerVector", AttributeContainerValue<IntegerValue, ';'>(ints));
 
     {
         // NOTE: changing the container here too!
-        AttributeContainerValue<IntegerValue> value;
+        AttributeContainerValue<IntegerValue, ';'> value;
         obj->GetAttribute("IntegerVector", value);
         NS_TEST_ASSERT_MSG_EQ(ints.size(), value.GetN(), "AttributeContainerValue wrong size");
 
         AttributeContainerValue<IntegerValue>::result_type intlist = value.Get();
         NS_TEST_ASSERT_MSG_EQ(ints.size(), intlist.size(), "Intvec wrong size");
-        auto iter = ints.begin();
-        for (auto d : intlist)
-        {
-            NS_TEST_ASSERT_MSG_EQ(d, *iter, "Incorrect value in intvec");
-            ++iter;
-        }
+
+        NS_TEST_ASSERT_MSG_EQ(std::equal(ints.begin(), ints.end(), intlist.begin()),
+                              true,
+                              "Incorrect value in intvec");
+    }
+
+    std::string intVecPairString("0 1,2,3; 1 0; 2 0,1");
+    // NOTE: here the underlying attribute container type differs from the actual container
+    obj->SetAttribute("IntVecPairVec", StringValue(intVecPairString));
+
+    {
+        using IntVecMapValue = PairValue<IntegerValue, AttributeContainerValue<IntegerValue>>;
+
+        // NOTE: changing the container here too!
+        AttributeContainerValue<IntVecMapValue, ';'> value;
+        obj->GetAttribute("IntVecPairVec", value);
+        NS_TEST_ASSERT_MSG_EQ(3, value.GetN(), "AttributeContainerValue wrong size"); // 3 pairs
+
+        AttributeContainerValue<IntVecMapValue>::result_type reslist = value.Get();
+        NS_TEST_ASSERT_MSG_EQ(3, reslist.size(), "IntVecMapValue wrong size");
+        auto reslistIt = reslist.begin();
+        NS_TEST_ASSERT_MSG_EQ(reslistIt->first, 0, "Incorrect integer value in first pair");
+        NS_TEST_ASSERT_MSG_EQ(reslistIt->second.size(),
+                              3,
+                              "Incorrect number of integer values in first pair");
+        ++reslistIt;
+        NS_TEST_ASSERT_MSG_EQ(reslistIt->first, 1, "Incorrect integer value in second pair");
+        NS_TEST_ASSERT_MSG_EQ(reslistIt->second.size(),
+                              1,
+                              "Incorrect number of integer values in second pair");
+        ++reslistIt;
+        NS_TEST_ASSERT_MSG_EQ(reslistIt->first, 2, "Incorrect integer value in third pair");
+        NS_TEST_ASSERT_MSG_EQ(reslistIt->second.size(),
+                              2,
+                              "Incorrect number of integer values in third pair");
     }
 
     std::map<std::string, int> map = {{"one", 1}, {"two", 2}, {"three", 3}};
